/*
 * The Clear BSD License
 * Copyright 2017-2018 NXP
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted (subject to the limitations in the disclaimer below) provided
 *  that the following conditions are met:
 *
 * o Redistributions of source code must retain the above copyright notice, this list
 *   of conditions and the following disclaimer.
 *
 * o Redistributions in binary form must reproduce the above copyright notice, this
 *   list of conditions and the following disclaimer in the documentation and/or
 *   other materials provided with the distribution.
 *
 * o Neither the name of the copyright holder nor the names of its
 *   contributors may be used to endorse or promote products derived from this
 *   software without specific prior written permission.
 *
 * NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE.
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

#ifndef _PERIPHERALS_H_
#define _PERIPHERALS_H_

/***********************************************************************************************************************
 * Included files
 **********************************************************************************************************************/
#include "fsl_common.h"
#include "fsl_gpio.h"
#include "fsl_port.h"
#include "fsl_adc12.h"
#include "fsl_clock.h"
#include "fsl_lpi2c.h"
#include "fsl_lpuart.h"

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/***********************************************************************************************************************
 * Definitions
 **********************************************************************************************************************/
/* Definitions for BOARD_InitBUTTONSPeripheral functional group */
/* Alias for GPIOB peripheral */
#define BOARD_SW2_GPIO GPIOB
/* Alias for GPIOD peripheral */
#define BOARD_SW3_GPIO GPIOD

/* Definitions for BOARD_InitLEDsPeripheral functional group */
/* Alias for GPIOD peripheral */
#define BOARD_LEDS_GPIO GPIOD

/* Definitions for BOARD_InitTHERMISTORPeripheral functional group */
/* Alias for ADC1 peripheral */
#define BOARD_THERMISTOR_PERIPHERAL ADC1
/* THERMISTOR interrupt vector ID (number). */
#define BOARD_THERMISTOR_IRQN ADC1_IRQn
/* THERMISTOR interrupt handler identifier. */
#define BOARD_THERMISTOR_IRQHANDLER ADC1_IRQHandler

/* Definitions for BOARD_InitACCELPeripheral functional group */
/* BOARD_InitACCELPeripheral defines for LPI2C0 */
/* Definition of peripheral ID */
#define BOARD_ACCEL_PERIPHERAL LPI2C0
/* Definition of clock source */
#define BOARD_ACCEL_CLOCK_FREQ CLOCK_GetIpFreq(kCLOCK_Lpi2c0)
/* Transfer buffer size */
#define BOARD_ACCEL_MASTER_BUFFER_SIZE 1
/* Alias for GPIOB peripheral */
#define BOARD_ACCEL_INT_RST_GPIO GPIOB

/* Definitions for BOARD_InitDEBUG_UARTPeripheral functional group */
/* Definition of peripheral ID */
#define BOARD_DEBUG_UART_PERIPHERAL LPUART1
/* Definition of the clock source frequency */
#define BOARD_DEBUG_UART_CLOCK_SOURCE 8000000UL

/***********************************************************************************************************************
 * Global variables
 **********************************************************************************************************************/
extern const adc12_config_t BOARD_THERMISTOR_config;
extern adc12_channel_config_t BOARD_THERMISTOR_channelsConfig[2];
extern const adc12_hardware_average_mode_t BOARD_THERMISTOR_hardwareAverageConfig;
extern const lpi2c_master_config_t BOARD_ACCEL_masterConfig;
extern lpi2c_master_transfer_t BOARD_ACCEL_masterTransfer;
extern uint8_t BOARD_ACCEL_masterBuffer[BOARD_ACCEL_MASTER_BUFFER_SIZE];
extern lpi2c_master_handle_t BOARD_ACCEL_masterHandle;
extern const lpuart_config_t BOARD_DEBUG_UART_config;

/***********************************************************************************************************************
 * Initialization functions
 **********************************************************************************************************************/
void BOARD_InitPeripherals(void);
void BOARD_InitBUTTONSPeripheral(void);
void BOARD_InitLEDsPeripheral(void);
void BOARD_InitTHERMISTORPeripheral(void);
void BOARD_InitACCELPeripheral(void);
void BOARD_InitDEBUG_UARTPeripheral(void);

/***********************************************************************************************************************
 * BOARD_InitBootPeripherals function
 **********************************************************************************************************************/
void BOARD_InitBootPeripherals(void);

#if defined(__cplusplus)
}
#endif

#endif /* _PERIPHERALS_H_ */
